# loops_practice_solutions.py
# Many contributers: many questions taken from CS 1110 Prelims

# (1) This first function is a regular for-loop; range is not required
def find_max(my_list):
    """
    Returns the maximum integer in the integer list my_list.
    Note: my_list remains unchanged.

    my_list: a list of integers with at least 1 element

    Examples:
    find_max([0]) Returns 0
    find_max([4,0,12]) Returns 12
    find_max([-4,-10,-2]) Returns -2
    """
    max = my_list[0]
    for x in my_list:
        if x > max:
            max = x
    return max
    # This question is problem 2(a) on Spring 2019 Prelim 2


# (2) From lab 11, part 1
def clamp(alist, floor, ceiling):
    """
    Does not return anything.  Rather, modifies `alist` so that every element is
    between `floor` and `ceiling`, as follows:

        * Any element less than `floor` is replaced with `floor`.
        * Any element greater than `ceiling` is replaced with `ceiling`.
        * No other elements are changed.

    Example: if `alist` is [-1, 1, 3, 5], then clamp(alist,0,4) changes
    `alist` to have [0,1,3,4] as its contents.

    Preconditions:
        `alist` is a (possibly empty) list of ints
        `floor` and `ceiling are floats or ints, and `floor` <= `ceiling`
    """
    for k in range(len(alist)):
        if alist[k] < floor:
            alist[k] = floor
        elif alist[k] > ceiling:
            alist[k] = ceiling

# (3) This function will require the use of range; you must loop over
# indices, not just the elements
def skipmult(alist,n,k):
    """MODIFIES alist to multiply every kth element by n (starting at 0).

    Example: Suppose a = [1, 3, 5, 7]. skipmult(a,2,2) makes a == [2, 3, 10, 7]
    (positions 0 and 2). Similarly, skipmult(a,2,3) makes a == [2, 3, 5, 14].

    Precondition: alist is a list of numbers (int or float)
    Precondition: n is number (int or float), k is an int > 1
    """

    for pos in range(len(alist)):
        if pos % k == 0:
            alist[pos] = alist[pos]*n
    # This is question 2(a) on Fall 2019, Prelim 2

    # I recommend showing students why range is necessary here.
    # for element in alist:
    #     pos = alist.index(element)
    #     if pos % k == 0:
    #         alist[pos] = alist[pos]*n
    # Show them that this fails on a = [4,3,3] when we call skipmult(a,2,2)
    # We should get a == [8,3,6], but we'll instead get [8,3,3]. Because the 3
    # is repeated, this code does not realize that there is a value at the
    # even position 2. Notice, pos = alist.index(3) always returns 1 because
    # what is at position 1 (the value 3) never changes

# (4) This for-loop is more complicated. You can use of both types of for loops.
# Can you see how?

def nullify_dups(table):
    """ This function will edit a table to set all duplicate values to
    0. If an entry in table is listed prior in table, the entry is set to
    0. On an element's first occurrence, it says its original value.

    Recall, a nested list in Python can be thought of as a table, where
    the list [[1,2,3],[1,2,4],[4,5,3]] can be written as the table
        1 2 3
        1 2 4
        4 5 3
    If we called nullify_dups([[1,2,3],[1,2,4],[4,5,3]]), the output would be
        1 2 3
        0 0 4
        0 5 0
    If any entries in the list are 0, they will stay 0.

    Precondition: table is a nested list, where each list inside of table
    is a list of integers
    """

    non_dups = []
    for row in table:
        for i in range(len(row)):
            if row[i] in non_dups:
                row[i] = 0
            else:
                non_dups.append(row[i])
    # Okay, I wrote this function but zerocols on Fall 2020 Prelim 2 might be better



# (5) This for loop is for practice with dictionaries.
def encode(cipher,text):
    """Returns an encoded copy of text using given cipher dictionary
    Example: encode({'a':'o','z':'b'},'razzle') returns 'robble'
    Precondition: cipher is good with lowercase letters as keys and values
    Precondition: text is a (possibly empty) string of lowercase letters"""
    result = ''
    for letter in text:
        if letter in cipher:
            result = result+cipher[letter]
        else:
            result = result+letter
    return result

    #Perhaps show students why this soltuion doesn't work: we cannot get parts
    # of a dictionary with indices
    # result = ''
    # for idx in range(len(cipher)):
    #     if cipher[idx] in cipher:
    #         result = result+cipher[cipher[idx]]
    #     else:
    #         result = result+cipher[idx]
    # return result

    # This question is problem 2 on Fall 2018 Prelim 2
